.macro DrawCube fCenter, fSize, iUseNumber

       lq _SDCfTag, kGIF_TAG_COLOR_TEXTURED_TRISTRIP(vi00)
       sq _SDCfTag, k256_QWORDS(vi00)
       ilw.x _SDCiNLoop, k256_QWORDS(vi00)
       iaddiu _SDCiNLoop, _SDCiNLoop, 3
       isw.x _SDCiNLoop, k256_QWORDS(vi00)

  iaddiu _SDCiOffset, vi00, k256_QWORDS
  iaddiu _SDCiOffset, _SDCiOffset, 1
  loi 255

  iaddiu _SDCiColor, vi00, 128
  mfir.xyzw _SDCfColor, _SDCiColor
  

;  mul.w _SDCfColor, vf00, i

  MatrixLoad _SDCmTransformation, kTRANSFORM_MATRIX, vi00
  MatrixCorrectAspect _SDCmTransformation, _SDCmTransformation
  MatrixLoad _SDCmLight1, kLIGHT_1_MATRIX, vi00
  MatrixLoad _SDCmLight2, kLIGHT_2_MATRIX, vi00
  MatrixLoad _SDCmLight3, kLIGHT_3_MATRIX, vi00
  lq _SDCfAmbientLight, kLIGHT_AMBIENT(vi00)
  loi 255
  sub _SDCfMaxLight, vf00, vf00
  add.xyz _SDCfMaxLight, _SDCfMaxLight, i

; Front

; Point 1
  sqi _SDCfColor, (_SDCiOffset++)

  sub _SDCfST, vf00, vf00
  sqi _SDCfST, (_SDCiOffset++)

  move _SDCfPoint, vf00
  sub.xy _SDCfPoint, _SDCfPoint, \fSize
  add.z _SDCfPoint, _SDCfPoint, \fSize

  MatrixMultiplyVector _SDCfTransformed, _SDCmTransformation, _SDCfPoint
  add.xyz _SDCfTransformed, _SDCfTransformed, \fCenter
  ftoi4 _SDCfTransformed, _SDCfTransformed
  sqi _SDCfTransformed, (_SDCiOffset++)

; Point 3
  sqi _SDCfColor, (_SDCiOffset++)

  sub _SDCfST, vf00, vf00
  add.y _SDCfST, _SDCfST, vf00[w]
  sqi _SDCfST, (_SDCiOffset++)

  move _SDCfPoint, vf00
  sub.x _SDCfPoint, _SDCfPoint, \fSize
  add.yz _SDCfPoint, _SDCfPoint, \fSize

  MatrixMultiplyVector _SDCfTransformed, _SDCmTransformation, _SDCfPoint
  add.xyz _SDCfTransformed, _SDCfTransformed, \fCenter
  ftoi4 _SDCfTransformed, _SDCfTransformed
  sqi _SDCfTransformed, (_SDCiOffset++)

; Point 2
  sqi _SDCfColor, (_SDCiOffset++)

  sub _SDCfST, vf00, vf00
  add.xy _SDCfST, _SDCfST, vf00[w]
  sqi _SDCfST, (_SDCiOffset++)

  move _SDCfPoint, vf00
  add.xyz _SDCfPoint, _SDCfPoint, \fSize

  MatrixMultiplyVector _SDCfTransformed, _SDCmTransformation, _SDCfPoint
  add.xyz _SDCfTransformed, _SDCfTransformed, \fCenter
  ftoi4 _SDCfTransformed, _SDCfTransformed
  sqi _SDCfTransformed, (_SDCiOffset++)

  KICK k256_QWORDS

.endm