.macro Initialize
	lq fRandomSeed, kDemoState(vi00)
	rinit r, fRandomSeed[z]

	BranchIfState kStateInitialized, lInitDone

	isw.xyzw vi00, kSTATE(vi00)

	MatrixIdentity mTransform
	MatrixSave mTransform, kTRANSFORM_MATRIX, vi00


; Purple light from up, right
	sub fLightNormal, vf00, vf00
	loi 0.301511345
	add.xz fLightNormal, fLightNormal, i
	loi -0.904534034
	add.y fLightNormal, fLightNormal, i

	loi 128
	mul mLight[0], fLightNormal, i
	sub mLight[1], vf00, vf00
	loi 255
	mul mLight[2], fLightNormal, i
	sub mLight[3], vf00, vf00

	MatrixTranspose mTransposeLight, mLight
	MatrixSave mTransposeLight, kLIGHT_1_MATRIX, vi00

; Red light from behind
	sub fLightNormal, vf00, vf00
	loi -1
	add.z fLightNormal, fLightNormal, i

	loi 255	
	mul mLight[0], fLightNormal, i
	sub mLight[1], vf00, vf00
	sub mLight[2], vf00, vf00
	sub mLight[3], vf00, vf00

	MatrixTranspose mTransposeLight, mLight
	MatrixSave mTransposeLight, kLIGHT_2_MATRIX, vi00

; Green light from below
	sub fLightNormal, vf00, vf00
	loi 1
	add.y fLightNormal, fLightNormal, i

	loi 255	
	sub mLight[0], vf00, vf00
	mul mLight[1], fLightNormal, i
	sub mLight[2], vf00, vf00
	sub mLight[3], vf00, vf00

	MatrixTranspose mTransposeLight, mLight
	MatrixSave mTransposeLight, kLIGHT_3_MATRIX, vi00

; Ambient light
	loi 16
	sub fAmbientLight, vf00, vf00
	add.xyz fAmbientLight, fAmbientLight, i
	sq fAmbientLight, kLIGHT_AMBIENT(vi00)

	SetState kStateInitialized
	SetState kStateSphereLOD

; Start fading, 127 frames
	iaddiu iFade, vi00, 255
	isw.y iFade, kSTATE(vi00)	
	SetState kStateFadingFromNoise

lInitDone:
	lq fRandomSeed, kDemoState(vi00)
	rinit r, fRandomSeed[z]
.endm
