; winds.vcl
; Copyright (C) 2003 Martin Piper
;

.init_vf_all	;
.init_vi_all	;
.syntax new

.include "winds.i"
















;
;| working algorythm for pt and triangles 
;V

;--enter
;--endenter
	ILW.x	cont,	CONT1(vi00)	;
	LQ	red,	RED(vi00)	;
	LQ	point,	POINT(vi00)	;
	
	LQ	m0,	M0(vi00)	;
	LQ	m1,	M1(vi00)	;
	LQ	m2,	M2(vi00)	;
	LQ	m3,	M3(vi00)	;

	LQ	gt_pt,  GT_POINT(vi00)	;
	LQ	gt_eop, GT_EOP(vi00)	;
	LQ	gt_tri, GT_TRIANGLE(vi00);

	IADDIU  o_buf,	vi00, O_BUFFER	;
draw_pt:
	

	SQI	gt_pt,	(o_buf++)	;
	FTOI0	red,	red		;
	SQI	red,	(o_buf++)	;
	
	MULAx	acc,	m0,	point	;
	MADDAy	acc,	m1,	point	;
	MADDAz	acc,	m2,	point	;
	MADDw	point,	m3,	point	;

	FTOI4	point,	point		;
	
	SQI	point,	(o_buf++)	;

	
	
;draw triangle
	IADD	buf_s,	vi00, o_buf	; save starting point of buffer
	SQI	gt_tri,	(o_buf++)	; insert gifTag into buffer
	IADD	n_tris,	vi00, vi00	; start counter for total triangles
	IADDIU  tvp,	vi00,	0	; triangle verts pointer

draw_triangle:
	SQI	red,	(o_buf++)	;
	IADDIU  tvs,	vi00, 3		; tvs = Triangle verts

calc_vert:
	MOVE	tv,	vf00		;	
	LQ.xyz	tv,	TRIANGLE(tvp)	; tv = Triangle vertex
	ILW.w	tri_c,	TRIANGLE(tvp)	; tri_c = triangle control	
	
	MULAx	acc,	m0,	tv	
	MADDAy	acc,	m1,	tv
	MADDAz	acc,	m2,	tv
	MADDw	tv,	m3,	tv
	
	FTOI4	tv,	tv
	SQI	tv,	(o_buf++)

	ISUBIU  tvs,	tvs,	1
	IADDIU	tvp,	tvp,	1
	IBNE	tvs,	vi00,	calc_vert ;check if we are done with this triangle
	

	IADDIU	n_tris, n_tris,	1	;increment triangles drawn
	IBNE	tri_c,	vi00,	finish_draw;
	ISUBIU	tvp,	tvp,	2	; step back 2 points
	B	draw_triangle

finish_draw: 
	ISWR.x	n_tris,	(buf_s)
	SQI	gt_eop, (o_buf++)	;
	IADDIU	o_buf,	vi00, O_BUFFER	;
	XGKICK	o_buf,	



;--exit
;--endexit

;//

END















