/*  GIMP header image file format (RGB): /ext/home/fin/ps2/vu_coding_contest_2003_ps2linux/plain_harness/demosrc/bubble/pic/tile.h  */

static unsigned int width = 64;
static unsigned int height = 32;

/*  Call this macro repeatedly.  After each use, the pixel data can be extracted  */

#define HEADER_PIXEL(data,pixel) {\
  pixel[0] = (((data[0] - 33) << 2) | ((data[1] - 33) >> 4)); \
  pixel[1] = ((((data[1] - 33) & 0xF) << 4) | ((data[2] - 33) >> 2)); \
  pixel[2] = ((((data[2] - 33) & 0x3) << 6) | ((data[3] - 33))); \
  data += 4; \
}
static char *header_data =
	"!!!!?(BY86V>9W.D35F*6F:7$1U.(R]@9W.D5F*3$Q]0'2E::'2E:'2E6F:7:76F"
	":'2E+CIK!!!!!!!!!!!!!!!!!!!!!!!!L[_PS=H*P<W^O<GZF*359G*C+SML7&B9"
	"8&R=35F*/$AY0DY_&\"15/TM\\5V.4<'RM9G*C9W.D5V.4\"Q=(76F:0$Q]-4%R-4%R"
	"%R-41E*#?8FZG*C9,CYO'RM<45V.-D)S)C)C'RM<&256#AI+!!!!!!!!FJ;7M\\/T"
	"!!!!!!!!!!!!!!!!!!!!!!!!!!!!AI+#DY_0EZ/4FZ?8.T=X!!!!(2U>2U>(:76F"
	"6F:7,S]P/DI[A9'\";GJK=H*S/DI[.T=X$1U.M,#QE:'2HZ_@P,S]EJ+3\"A9'76F:"
	"256&0T]`.T=X,#QM$1U.!!!!!!!!!!!!!!!!!!!!!!!!!!!!&2560T]`?8FZJ;7F"
	"O<GZN\\?XDI[/L[_P6&25!!!!!!!!/TM\\.45V97&B=H*S;WNLC9G*!!!!IK+CP,S]"
	"!!!!V.45T]`0P,S]U>(2M\\/T04U^&B97:G:GB97&?8FZ=(\"Q76F:+#AI!!!!'BI;"
	"256&$1U.BY?(A9'\";GJK>86V#AI+:W>H0$Q]>X>XJ[?HJK;GD)S-DI[/(BY?-$!Q"
	"0DY_-$!Q$!Q-!!!!*#1EAY/$R-4%G*C9JK;GN<7VH*S=!!!!O<GZRM<'P\\_`O\\O\\"
	"H*S=L[_PA)#!LK[O/$AY0$Q]O\\O\\L[_PN<7VP\\_`DY_0?8FZB)3%!!!!N\\?XF*35"
	"!!!!RM<'TM\\/Q-$!O,CYP\\_`/TM\\!!!!/4EZ:G:G:W>HC)C)6V>876F:1E*#%R-4"
	"!!!!4EZ/BI;'>(2U;GJK,#QM/TM\\BY?(?8FZ#AI+EZ/4J;7F@8V^>X>X6&25%R-4"
	"&256!!!!+SMLFJ;7KKKKQM,#I;'BM\\/TFJ;7G*C9>86V'\"A9D9W.M<'RIK+CI;'B"
	"C)C)NL;WA9'\"GZO<'BI;;GJKP,S]G:G:LK[OM\\/T?8FZD)S-@8V^!!!!L;WNB97&"
	"!!!!PL[_S=H*O<GZQ=(\"/$AY?HJ[04U^$!Q-=(\"Q;WNL35F*<'RM8FZ?2U>(*S=H"
	"(R]@<GZO>(2UAI+#>86V#AI+<W^PCYO,;'BI0$Q]1U.$DI[/<'RM+CIK*35F9'\"A"
	"DY_0%B)3J+3EI+#AM\\/TE:'2L[_P?XN\\F:76HZ_@=H*S,3UN:G:GNL;WJ+3EHJ[?"
	"IK+CBY?(?8FZ<7VN!!!!F:76P<W^R]@(O,CYF*35I+#A>H:W;'BI!!!!DI[/L[_P"
	"!!!!TM\\/RM<'Q=(\"/4EZAI+#KKKKI[/D.D9W-D)S8FZ?9W.D5F*3:W>H6&25\"Q=("
	"6666>86V:'2E6V>8-4%R/DI[?(BY=(\"Q=X.T,#QM!!!!+CIK;GJKB97&I;'BM,#Q"
	"I+#AC)C)(\"Q=J[?HC)C)I[/D86V>:W>H<W^P8&R=4EZ/0DY_/DI[N<7V9'\"A?(BY"
	"45V.-T-T(BY?!!!!!!!!M\\/TJ[?HP<W^LK[OJ[?HDY_0HZ_@IK+C!!!!E*#17FJ;"
	"!!!!RM<'P\\_`04U^@HZ_HJ[?F:76I;'B<7VN!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
	"4EZ/6V>85&\"16V>8#!A)8V^@?HJ[=(\"Q0T]`!!!!;GJKPL[_QM,#L+SMOLK[M,#Q"
	"HZ_@K;GJ'\"A9<7VNL;WNI;'BHZ_@?XN\\?XN\\8&R=9'\"A'\"A9!!!!!!!!04U^1%\"!"
	"<W^PA9'\"@8V^E:'2!!!!I[/DJ;7FHZ_@E*#1>X>XBI;';7FJ;7FJ!!!!!!!!0$Q]"
	"!!!!RM<'04U^>X>XM\\/TIK+CE:'2CYO,)C)C3UN,OLK[Q-$!OLK[K+CIJ[?H2E:'"
	"!!!!/DI[56&2*S=H,S]P97&B<7VN7VN<#1E*/TM\\L+SMOLK[H*S=GJK;BI;'DY_0"
	"DY_0CIK+:76F)C)CJK;G?(BYI+#A<GZOB97&2U>('BI;!!!!D)S-O<GZSML+BY?("
	"JK;GI;'BIK+C?8FZ!!!!CIK+ML+SH*S=DI[/BY?(CIK+9'\"A6F:7!!!!S=H*V^@8"
	"!!!!0DY_A)#!Q=(\"EZ/4F:76K+CI>(2U!!!!J+3EOLK[L[_PL[_PH*S=J;7FI;'B"
	"=(\"Q$AY/1U.$#1E*97&B>86V:W>H&R=8%B)3IK+CJ;7FF:76D)S-M<'RNL;WC)C)"
	"BI;'I[/D?(BY-$!Q3UN,A9'\"<7VN2U>(3%B)(R]@!!!!D)S-J[?HM<'RL;WNI[/D"
	"I;'BHZ_@8V^@GJK;!!!!G:G:E*#1H:W>E*#19G*CDI[/;'BI3EJ+!!!!W>H:P,S]"
	"!!!!?HJ[IK+CM\\/TI;'BEZ/4GJK;,CYO15&\"KKKKEZ/4EZ/4GZO<GJK;I;'BGZO<"
	"?8FZ:76F*35F!!!!!!!!!!!!!!!!!!!!B97&H*S=J;7F@8V^DY_0M<'RGZO<DI[/"
	"DY_0=X.T:G:G>(2U$AY/?XN\\=8&R6V>8&\"15A)#!!!!!I[/DP,S]H:W>H:W>L;WN"
	"EJ+3I;'B>(2UK;GJ!!!!E:'2F:76DI[/?8FZA)#!>(2U86V>7&B9!!!!V^@8QM,#"
	"!!!!O,CYK[OLF:76@X^`E:'2IK+C$!Q-F*35H*S=FZ?8G:G:=H*SGJK;FZ?8;WNL"
	";GJK?HJ[0DY_0$Q]PL[_N<7VN<7V7VN<=(\"QN,3UBI;'J;7FLK[OD)S-G:G:K+CI"
	"D)S-DI[/=8&R8V^@2E:'.D9W.$1U+SMLI+#AK;GJ*35FF:76R-4%K[OLH:W>BI;'"
	"BI;'I[/D:'2E<GZO!!!!I;'B>H:W97&B6&25*#1E*35F%R-4!!!!!!!!T=X.M,#Q"
	"!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!1U.$A)#!KKKKC)C)E*#1=8&REJ+3CYO,"
	"8V^@BY?(+3EJ8V^@P\\_`LK[OFJ;7.$1U*35F;GJKL+SMH*S=@(R];7FJB)3%EJ+3"
	"6V>8B97&9'\"A=8&R(2U>!!!!4U^0M<'RP<W^M\\/T2E:'35F*KKKKCYO,I[/DJ+3E"
	"I[/D7FJ;9G*C.D9W!!!!!!!!*C9G-D)S0$Q]9'\"A5V.4:'2E?XN\\!!!!K+CIS=H*"
	"!!!!SML+UN,3S]P,S]P,N\\?XS]P,G:G:+3EJ-D)S@8V^FJ;7>X>XDI[/9G*CF:76"
	"9G*C97&B!!!!BY?(Q-$!J;7F:76F;'BIDY_0$1U.:76FF:76J[?HAI+#;WNLA9'\""
	":76F76F:;WNL(2U>&\"15AI+#N,3UN,3UN\\?XF*35:W>H+#AIA)#!L+SM>(2U;WNL"
	"@HZ_H*S=?HJ[#!A)3UN,H:W>N,3UF*35F:76I+#AD)S-B97&@(R]&B97BI;'P<W^"
	"!!!!Q=(\"R]@(Q-$!Q]0$S-D)P\\_`L[_PNL;WDI[/*C9G5F*36V>85&\"13%B))S-D"
	")#!A!!!!!!!!HJ[?IK+CA9'\"35F*F*35KKKK;GJK!!!!3UN,>86V:76F>86V6V>8"
	"9W.D;WNL(R]@,3UNI;'BR]@(P<W^N<7VFJ;7=H*S)3%B!!!!B97&E:'2I;'BI[/D"
	"C)C)3UN,15&\"%2%2@HZ_JK;GK[OL@8V^A9'\">(2U<7VND9W.9G*C,3UN6&25R-4%"
	"!!!!Q-$!Q=(\"O\\O\\T-T-N<7VHJ[?;GJK5V.40$Q]!!!!!!!!!!!!15&\"15&\"B)3%"
	"@HZ_K[OL!!!!N<7VJ;7FEJ+3)C)CK[OLK[OLA)#!.T=X!!!!#QM,+SML6&252%2%"
	"45V.'RM<6F:7Q]0$Q-$!O,CYM\\/TB)3%)C)C'RM<8V^@$1U.7FJ;FJ;7J+3E45V."
	"@8V^1U.$#!A)=H*SN\\?XKKKKJ+3EC9G*A9'\"B)3%8FZ?1%\"!6F:70T]`1E*#PL[_"
	"!!!!KKKKBI;'6&25/TM\\!!!!$AY/,3UN0DY_6&250DY_2U>(SML+S]P,UN,3RM<'"
	"N,3UL[_P!!!!K+CIGZO<2%2%4U^0DI[/BY?(?8FZ4U^0/TM\\JK;G>(2U3EJ+04U^"
	"!!!!!!!!JK;GP,S]J[?HCIK+)S-D(2U><'RMAY/$@8V^2%2%,CYO6&259'\"A+CIK"
	"*S=H!!!!!!!!?8FZLK[OK[OL;WNLIK+C:76F@(R]97&B5F*31E*#/DI[!!!!!!!!"
	"!!!!%\"!1-T-T66666F:7HJ[?G*C9:W>H;WNL=(\"Q,3UND)S-SML+O<GZU.$1GZO<"
	"ML+SI+#A*S=H:76FL;WN'2E:?(BYI[/DE:'2D9W.15&\"3UN,JK;GQM,#M,#QN<7V"
	"I;'B$AY/45V.E*#1*C9G)3%B=H*SB97&A)#!@X^`=8&R:76F!!!!&B97256&<W^P"
	"?HJ[OLK[%2%276F:BY?(GZO<C)C)86V>;7FJ7VN<8&R=2%2%.T=X!!!!76F:VN<7"
	"!!!!I+#AIK+CG:G:AI+#DI[/>H:W8V^@?(BY>86V!!!!T=X.UN,3NL;WSML+OLK["
	"L[_PK+CI+SML:G:G8&R=%B)3J[?HAY/$I[/DAY/$+3EJAI+#Q-$!KKKKNL;WK+CI"
	"BY?(6666!!!!(2U>=X.TC)C)DI[/<GZO?XN\\97&B;GJK:W>H!!!!Q=(\"S]P,R=8&"
	"I[/DL;WN6V>8%\"!1:W>H=X.T97&BA9'\"35F*;WNL:G:G6V>8$!Q-&R=8W>H:W>H:"
	"!!!!H*S=FJ;7=8&RBY?(=(\"Q9W.D?(BY7&B9.T=X0DY_R=8&Q]0$P,S]M\\/TL[_P"
	"FJ;7J+3E/DI[,S]P0DY_1%\"!EJ+3FJ;7?XN\\AI+##AI+J;7FQ-$!O<GZL[_PF*35"
	"I+#ACYO,$Q]0>H:WC)C)A9'\"=X.T?HJ[=(\"Q1E*#*C9G#1E*!!!!S]P,R-4%O,CY"
	"Q]0$G:G:J[?H%2%2;WNL<GZO>86V4U^07VN<-$!Q'BI;#AI+!!!!K+CIXN\\?R]@("
	"!!!!9G*CD9W.B97&=(\"Q86V>;GJK4U^06&25)#!A?XN\\U>(2T-T-L[_PJ[?HI[/D"
	"HJ[?O,CY/4EZ+SML!!!!<7VNE:'2EJ+3@HZ_:G:G!!!!KKKKK;GJJ[?HLK[OEZ/4"
	"CYO,=(\"Q/4EZ0DY_>(2U7&B9,3UN#QM,$Q]0-$!Q2%2%=(\"Q!!!!ML+SOLK[KKKK"
	"L[_PFJ;7<GZO4U^0-4%R86V>0$Q]%\"!1!!!!*#1E7VN<:76F!!!!L[_PT-T-O\\O\\"
	"!!!!>86VC)C)5V.4@HZ_8V^@:G:G97&B86V>!!!!O<GZR]@(PL[_HJ[?HJ[?FZ?8"
	"4EZ/C9G*5&\"1!!!!!!!!E*#19'\"A.D9W*35F!!!!!!!!KKKKML+SH*S=I+#AD9W."
	"GJK;;GJK0DY_!!!!&256-4%R97&BGZO<BY?(CIK+B97&;'BI!!!!QM,#I[/DJK;G"
	"K;GJGZO<GZO<7&B9!!!!(BY?0DY_>X>X@HZ_F:769'\"A76F:!!!!V>86Q-$!Q=(\""
	"!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!M<'RO,CYRM<'HZ_@R-4%H*S="
	"KKKK@(R]-T-T!!!!!!!!256&0T]`B)3%BI;'EZ/4!!!!GZO<HJ[?J[?HDI[/A)#!"
	"?HJ[7FJ;!!!!5&\"1M\\/TG:G:F:76I;'BH*S=?(BYD)S-@(R]!!!!O<GZK+CIO\\O\\"
	"HZ_@AI+#H*S=(R]@.45VG*C9I;'BK;GJA9'\";7FJ=8&R8V^@%\"!1F:76N,3UP\\_`"
	"!!!!ML+SDY_0F*35?HJ[>86V<'RM>(2U3%B)!!!!T=X.T=X.R]@(NL;WR=8&N<7V"
	";GJKJ+3E256&3%B)W>H:W^P<U.$1P\\_`ML+SE:'2!!!!J+3EL+SMC9G*=(\"QAI+#"
	"3EJ+$1U.04U^O<GZLK[OJ[?HK+CIDI[/@X^`I+#AF*35>H:W!!!!M,#QHJ[?O,CY"
	"B97&AY/$:G:G!!!!>H:WA)#!I[/D:'2EA)#!;'BI5&\"186V>%R-4@HZ_P,S]N\\?X"
	"!!!!A)#!:W>H?(BYGJK;7FJ;>86V9G*C<7VN!!!!U^04RM<'O\\O\\J+3EN,3UL+SM"
	"6F:745V.'RM<BI;'VN<7S]P,TM\\/Q]0$OLK[M,#Q!!!!HJ[?K+CIG:G:>86V@8V^"
	"%R-4&256E:'2HJ[?JK;GAY/$H*S=FJ;7B)3%>H:W8FZ?CIK+!!!!JK;GM\\/TGZO<"
	"HJ[?@HZ_5&\"1)C)CA9'\"=(\"QBY?(;WNL9W.D97&B6&250DY_*C9G8V^@N\\?XLK[O"
	"!!!!G*C9:W>H@X^`:76F4U^09'\"A7VN<3%B)!!!!O,CYP\\_`NL;WHZ_@P,S]=(\"Q"
	":G:G>(2U!!!!S=H*V.45PL[_P<W^P\\_`F*35H:W>!!!!!!!!!!!!!!!!!!!!!!!!"
	"!!!!<W^PJK;GB97&FZ?8F:76J+3EFZ?8?HJ[7VN<GZO<:W>H!!!!)C)C?(BYLK[O"
	"HJ[?CYO,+#AI.T=X@X^`A9'\"=(\"Q=H*S5F*36V>86F:79G*C.D9W04U^M\\/TJ+3E"
	"!Q-$86V>C)C)=H*S5V.48&R=56&2/TM\\0T]`!!!!M\\/TEJ+3<'RM45V.+#AI.$1U"
	")#!A!!!!!!!!S-D)SML+OLK[S]P,PL[_AI+#7FJ;<GZOI+#AL;WNDY_0E*#1C)C)"
	"+SML=X.TK[OLM,#QBI;'B)3%7VN<9G*CGZO<A)#!5V.4)#!A5V.4QM,#5V.4%2%2"
	"3%B)CYO,!!!!EZ/4CYO,F*358FZ?=X.T5F*39'\"A256&0$Q]*#1E/$AYDY_03EJ+"
	"\"Q=(:'2E>H:WCIK+76F:6&2545V.1%\"!)3%B!!!!!!!!,S]P3%B)2%2%B)3%>86V"
	"H*S=NL;W!!!!R]@(Q]0$TM\\/HJ[?FZ?8B97&$Q]04%R-G:G:G:G:F*35@X^`G*C9"
	"?XN\\-$!Q7FJ;FJ;7B97&IK+C>X>XFJ;7D9W.D9W.2E:'#!A)Q]0$_`P\\`0T]XN\\?"
	"CIK+'RM<!!!!6&25<'RM;7FJ56&29W.D7FJ;2U>(.D9W.$1U(\"Q=!!!!,S]P>H:W"
	"$AY/*C9GD9W.<7VN:G:G6&258&R=45V.\"15&:'2EW>H:U.$1VN<7U>(2S-D)OLK["
	"S-D)N,3U!!!!T]`0R]@(OLK[L;WNML+S6F:76F:7=(\"Q!!!!1U.$E*#1G:G:@X^`"
	"D)S-A)#!,CYO97&BG:G:J[?HEJ+36F:71E*#86V>.T=X.T=X_`P\\_`P\\_`P\\_`P\\"
	"_`P\\_`P\\.T=X(R]@@8V^8FZ?9W.D5F*3256&.T=X1E*#,S]P\"A9'9W.DX^`@TM\\/"
	"$Q]0)3%B:76F.D9W1%\"!'BI;'BI;!!!!!!!!R-4%X.T=V.45N\\?XU.$1S-D)S=H*"
	"NL;WAI+#!!!!SML+RM<'E:'2E*#1@8V^$!Q-ML+SS=H*I[/D1%\"!$Q]02U>(CYO,"
	"@(R]?(BY=X.T+3EJ9W.DAI+#=(\"Q?HJ[56&286V>\"Q=(@X^`_`P\\_`P\\^P<W`0T]"
	"\\/TM\\/TMHJ[?!!!!256&=H*S+3EJ+3EJ'BI;&256$1U.!!!!!!!!P<W^UN,3S]P,"
	"$AY/!!!!!!!!2U>(2%2%?8FZA)#!I+#A!!!!Y/$AT=X.U.$1S]P,NL;WQ=(\"I;'B"
	"T-T-BI;'!!!!!!!!!!!!!!!!!!!!!!!!!!!!GJK;Q=(\"O\\O\\S=H*@(R]%R-4$AY/"
	"8V^@=(\"QBI;'/$AY!!!!!!!!!!!!!!!!!!!!!!!!!!!!_`P\\\\/TM_`P\\Z_@HO\\O\\"
	"RM<'Y_0D_`P\\:W>H!!!!!!!!0DY_0DY_8V^@:'2E@(R]GJK;$Q]0QM,#T]`0UN,3"
	"$!Q-0$Q]SML+VN<7PL[_O\\O\\M<'RO\\O\\0DY_=8&RU>(2P<W^U>(2M,#QB97&I[/D"
	">86V15&\"0$Q]9'\"ADI[/B)3%=(\"QB97&'BI;&256GJK;R-4%PL[_N,3UM\\/T2E:'"
	"!!!!&R=8<W^P#1E*86V>?XN\\<W^PA)#!:76FF:76%\"!1J[?H_`P\\_`P\\^`@XQ=(\""
	"UN,3T]`0O,CY8&R=4%R-RM<'OLK[P,S]K[OLKKKKHZ_@FJ;7?8FZ,3UNU>(2VN<7"
	"\"A9'>86VO\\O\\O\\O\\PL[_P<W^R-4%A)#!DI[/,#QMV.45PL[_T-T-O,CYLK[O;'BI"
	"C9G*!!!!<7VN;WNL@8V^G*C9@8V^56&21E*##!A)0DY_NL;WP,S]JK;G@X^`E*#1"
	">86V)S-D!!!!+3EJ8&R=E:'2>H:WG*C9?(BY8FZ?:W>H#1E*H*S=_@HZ_`P\\SML+"
	"NL;WX>X>R=8&&\"15HZ_@L+SMO<GZR-4%HJ[?C)C)E*#1I[/DI[/D+#AIC9G*P,S]"
	"";
