/*  GIMP header image file format (RGB): /ext/home/fin/ps2/bubble/pic/tilemusterbw.h  */

static unsigned int width = 64;
static unsigned int height = 32;

/*  Call this macro repeatedly.  After each use, the pixel data can be extracted  */

#define HEADER_PIXEL(data,pixel) {\
  pixel[0] = (((data[0] - 33) << 2) | ((data[1] - 33) >> 4)); \
  pixel[1] = ((((data[1] - 33) & 0xF) << 4) | ((data[2] - 33) >> 2)); \
  pixel[2] = ((((data[2] - 33) & 0x3) << 6) | ((data[3] - 33))); \
  data += 4; \
}
static char *header_data =
	"3%B)3%B)3%B)3%B)3%B)3%B)3%B)3%B)3%B)3%B)3%B)3%B)3%B)3%B)3%B)7VN<"
	"P<W^3%B)CIK+Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$ACIK+3%B)P<W^"
	"7VN<3%B)3%B)3%B)3%B)3%B)3%B)3%B)3%B)3%B)3%B)3%B)3%B)3%B)3%B)3%B)"
	"3%B)3%B)3%B)3%B)3%B)3%B)3%B)3%B)CIK+CIK+3%B)3%B)3%B)7VN<P<W^Y/$A"
	"Y/$A7VN<3%B)7VN<P<W^Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AP<W^7VN<3%B)7VN<Y/$A"
	"Y/$AP<W^7VN<3%B)3%B)3%B)CIK+CIK+3%B)3%B)3%B)3%B)3%B)3%B)3%B)3%B)"
	"3%B)3%B)3%B)3%B)3%B)3%B)3%B)3%B)P<W^Y/$A7VN<3%B)CIK+Y/$AY/$AY/$A"
	"Y/$ACIK+3%B)3%B)CIK+Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$ACIK+3%B)3%B)CIK+Y/$A"
	"Y/$AY/$AY/$ACIK+3%B)7VN<Y/$AP<W^3%B)3%B)3%B)3%B)3%B)3%B)3%B)3%B)"
	"3%B)3%B)3%B)3%B)3%B)3%B)3%B)7VN<Y/$AY/$AP<W^3%B)Y/$AY/$AY/$AY/$A"
	"Y/$ACIK+7VN<P<W^Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AP<W^7VN<CIK+Y/$A"
	"Y/$AY/$AY/$AY/$A3%B)P<W^Y/$AY/$A7VN<3%B)3%B)3%B)3%B)3%B)3%B)3%B)"
	"3%B)3%B)3%B)3%B)3%B)3%B)3%B)CIK+Y/$AY/$AY/$AP<W^Y/$AY/$AY/$AY/$A"
	"Y/$AP<W^Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AP<W^Y/$A"
	"Y/$AY/$AY/$AY/$AP<W^Y/$AY/$AY/$ACIK+3%B)3%B)3%B)3%B)3%B)3%B)3%B)"
	"3%B)3%B)CIK+3%B)3%B)3%B)3%B)CIK+Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AP<W^P<W^Y/$A"
	"Y/$AP<W^P<W^Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$ACIK+3%B)3%B)3%B)3%B)CIK+3%B)3%B)"
	"3%B)3%B)P<W^7VN<3%B)3%B)3%B)7VN<Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AP<W^T]`0Y/$A"
	"Y/$AT]`0P<W^Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$A7VN<3%B)3%B)3%B)7VN<P<W^3%B)3%B)"
	"3%B)3%B)P<W^CIK+3%B)3%B)3%B)3%B)Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$AT]`0Y/$AY/$AY/$AY/$A7VN<Y/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$A7VN<Y/$AY/$AY/$AY/$AT]`0Y/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$A3%B)3%B)3%B)3%B)CIK+P<W^3%B)3%B)"
	"3%B)7VN<Y/$AP<W^3%B)3%B)3%B)3%B)P<W^Y/$AY/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$ACIK+3%B)CIK+Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$ACIK+3%B)CIK+Y/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$AY/$AP<W^3%B)3%B)3%B)3%B)P<W^Y/$A7VN<3%B)"
	"P<W^P<W^Y/$AY/$A7VN<3%B)3%B)3%B)CIK+Y/$AY/$AY/$AY/$ACIK+P<W^P<W^"
	"P<W^P<W^P<W^CIK+3%B)3%B)3%B)CIK+Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$ACIK+3%B)3%B)3%B)CIK+P<W^P<W^P<W^"
	"P<W^P<W^CIK+Y/$AY/$AY/$AY/$ACIK+3%B)3%B)3%B)7VN<Y/$AY/$AP<W^P<W^"
	"Y/$AY/$AY/$AY/$AP<W^3%B)3%B)3%B)3%B)T]`0Y/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AT]`0CIK+3%B)P<W^Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AP<W^3%B)CIK+T]`0Y/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$AT]`03%B)3%B)3%B)3%B)P<W^Y/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AP<W^3%B)3%B)3%B)P<W^Y/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$AT]`0Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AT]`0Y/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$AP<W^3%B)3%B)3%B)P<W^Y/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$AP<W^CIK+P<W^Y/$AY/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$AY/$AT]`0Y/$AY/$AY/$AY/$AY/$AY/$AY/$ACIK+"
	"CIK+Y/$AY/$AY/$AY/$AY/$AY/$AY/$AT]`0Y/$AY/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$AY/$AP<W^CIK+P<W^Y/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AP<W^7VN<P<W^Y/$AY/$AY/$AY/$AT]`0Y/$AP<W^3%B)"
	"3%B)P<W^Y/$AT]`0Y/$AY/$AY/$AY/$AP<W^7VN<P<W^Y/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AT]`0P<W^P<W^Y/$AY/$AY/$AY/$ACIK+3%B)Y/$AY/$AY/$A"
	"Y/$AY/$AY/$A3%B)CIK+Y/$AY/$AY/$AY/$AP<W^P<W^T]`0Y/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AT]`07VN<3%B)3%B)P<W^Y/$AY/$A"
	"Y/$AY/$AP<W^3%B)3%B)7VN<T]`0Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$ACIK+3%B)3%B)P<W^Y/$AY/$A"
	"Y/$AY/$AP<W^3%B)3%B)CIK+Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$ACIK+CIK+Y/$AY/$AY/$AY/$AT]`0CIK+Y/$AY/$ACIK+"
	"CIK+Y/$AY/$ACIK+T]`0Y/$AY/$AY/$AY/$ACIK+CIK+Y/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$ACIK+CIK+Y/$AY/$AY/$AY/$AY/$AY/$AP<W^3%B)"
	"3%B)P<W^Y/$AY/$AY/$AY/$AY/$AY/$ACIK+CIK+Y/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$ACIK+3%B)CIK+Y/$AY/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AT]`0"
	"T]`0Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$AY/$ACIK+3%B)CIK+Y/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$A7VN<3%B)3%B)3%B)P<W^Y/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$ACIK+Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$ACIK+Y/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$AP<W^3%B)3%B)3%B)7VN<Y/$AY/$AY/$AY/$AY/$A"
	"CIK+Y/$AY/$AY/$ACIK+3%B)3%B)3%B)3%B)Y/$AY/$AY/$AY/$AP<W^P<W^P<W^"
	"Y/$AY/$AY/$AP<W^CIK+3%B)3%B)P<W^Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AP<W^3%B)3%B)CIK+P<W^Y/$AY/$AY/$A"
	"Y/$AY/$AP<W^Y/$AY/$AY/$AY/$A3%B)3%B)3%B)3%B)CIK+Y/$AY/$AY/$ACIK+"
	"3%B)CIK+Y/$AY/$A3%B)3%B)3%B)3%B)CIK+Y/$AY/$AY/$AY/$AP<W^T]`0Y/$A"
	"Y/$AY/$AP<W^P<W^CIK+3%B)3%B)CIK+Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$ACIK+3%B)3%B)CIK+P<W^P<W^P<W^P<W^"
	"P<W^P<W^P<W^Y/$AY/$AY/$AY/$ACIK+3%B)3%B)3%B)3%B)Y/$AY/$ACIK+3%B)"
	"3%B)3%B)Y/$AP<W^3%B)3%B)3%B)3%B)P<W^Y/$AY/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AT]`0CIK+P<W^Y/$AY/$AY/$AT]`0Y/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AT]`0Y/$AY/$AY/$AP<W^CIK+T]`0Y/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$AY/$AP<W^3%B)3%B)3%B)3%B)P<W^Y/$A3%B)3%B)"
	"3%B)3%B)P<W^CIK+3%B)3%B)3%B)3%B)Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$ACIK+Y/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$ACIK+Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$A3%B)3%B)3%B)3%B)CIK+P<W^3%B)3%B)"
	"3%B)3%B)CIK+3%B)3%B)3%B)3%B)7VN<Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$ACIK+CIK+Y/$A"
	"Y/$ACIK+CIK+Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$A7VN<3%B)3%B)3%B)3%B)CIK+3%B)3%B)"
	"3%B)3%B)7VN<3%B)3%B)3%B)3%B)CIK+Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AT]`0Y/$AY/$A"
	"Y/$AY/$AT]`0Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$ACIK+3%B)3%B)3%B)3%B)7VN<3%B)3%B)"
	"3%B)3%B)3%B)3%B)3%B)3%B)3%B)CIK+Y/$AY/$AY/$A7VN<Y/$AY/$AY/$AY/$A"
	"Y/$ACIK+P<W^Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AP<W^CIK+Y/$A"
	"Y/$AY/$AY/$AY/$A7VN<Y/$AY/$AY/$ACIK+3%B)3%B)3%B)3%B)3%B)3%B)3%B)"
	"3%B)3%B)3%B)3%B)3%B)3%B)3%B)3%B)Y/$AY/$ACIK+3%B)P<W^Y/$AY/$AY/$A"
	"Y/$ACIK+3%B)CIK+Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$ACIK+3%B)CIK+Y/$A"
	"Y/$AY/$AY/$AP<W^3%B)CIK+Y/$AY/$A3%B)3%B)3%B)3%B)3%B)3%B)3%B)3%B)"
	"3%B)3%B)3%B)3%B)3%B)3%B)3%B)3%B)P<W^P<W^3%B)3%B)3%B)P<W^Y/$AY/$A"
	"Y/$ACIK+3%B)3%B)CIK+Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$ACIK+3%B)3%B)CIK+Y/$A"
	"Y/$AY/$AP<W^3%B)3%B)3%B)P<W^P<W^3%B)3%B)3%B)3%B)3%B)3%B)3%B)3%B)"
	"3%B)3%B)3%B)3%B)3%B)3%B)3%B)3%B)CIK+7VN<3%B)3%B)3%B)3%B)CIK+T]`0"
	"Y/$A7VN<3%B)CIK+Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$ACIK+3%B)7VN<Y/$A"
	"T]`0CIK+3%B)3%B)3%B)3%B)7VN<CIK+3%B)3%B)3%B)3%B)3%B)3%B)3%B)3%B)"
	"3%B)3%B)3%B)3%B)3%B)3%B)3%B)3%B)3%B)3%B)3%B)3%B)3%B)3%B)3%B)3%B)"
	"CIK+3%B)CIK+Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$A"
	"Y/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$AY/$ACIK+3%B)CIK+"
	"3%B)3%B)3%B)3%B)3%B)3%B)3%B)3%B)3%B)3%B)3%B)3%B)3%B)3%B)3%B)3%B)"
	"";
